package jsf;

import ejb.GestionnaireDeCompteBancaire;
import entite.CompteBancaire;
import entite.OperationBancaire;
import java.util.List;
import javax.ejb.EJB;
import javax.inject.Named;
import javax.enterprise.context.RequestScoped;
import javax.faces.event.ComponentSystemEvent;

/**
 *
 * @author richard
 */
@Named(value = "affichageComptesController")
@RequestScoped
public class AffichageComptesController {
  @EJB
  private GestionnaireDeCompteBancaire gestionnaireDeCompteBancaire;
  /**
   * Pour voir les détails de ce compte.
   */
  private long idCompte;
  private CompteBancaire compteBancaire;

  /** Creates a new instance of AffichageComptes */
  public AffichageComptesController() {
  }
  
  public List<CompteBancaire> findAllComptes() {
    return gestionnaireDeCompteBancaire.findAll();
  }
  
  public String showDetails(long id) {
    this.idCompte = id;
    System.out.println("id=" + idCompte + " par " + this);
    return "details?faces-redirect=true&amp;includeViewParams=true";
  }
  
  public void chargeCompte(ComponentSystemEvent event) {
    System.out.println("id du compte =" + idCompte + " par " + this);
    if (compteBancaire == null) {
      compteBancaire = gestionnaireDeCompteBancaire.findById(idCompte);
    }
  }
  
  public List<OperationBancaire> getOperationsDuCompte() {
    return gestionnaireDeCompteBancaire.findOperationsDuCompte(idCompte);
  }

  public long getIdCompte() {
    return idCompte;
  }

  public void setIdCompte(long idCompte) {
    this.idCompte = idCompte;
  }
  
  public CompteBancaire getCompteBancaire() {
    return compteBancaire;
  }
}
